diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
index fd501ac4c..c5d2d7fcd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
@@ -4,6 +4,7 @@ import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
@@ -11,12 +12,12 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
-public class BlockLogicNote extends BlockLogic
-{
+public class BlockLogicNote extends BlockLogic {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final int MASK_NOTE = 0b0011_1111;
     public static final int MASK_POWERED = 0b1000_0000;
@@ -24,17 +25,16 @@ public class BlockLogicNote extends BlockLogic
     public static final byte MAX_NOTE = 24;
 
     public BlockLogicNote(@NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
         block.withEntity(null);
     }
 
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         boolean powered = world.hasNeighborSignal(tilePos);
         int data = world.getBlockData(tilePos);
-        if(isPowered(data) && !powered)
-        {
+        if (isPowered(data) && !powered) {
             world.setBlockData(tilePos, setPowered(data, false));
         } else if (!isPowered(data) && powered) {
             triggerNote(world, tilePos);
@@ -43,7 +43,7 @@ public class BlockLogicNote extends BlockLogic
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (!world.isClientSide) {
             changePitch(world, tilePos, player.isSneaking() ? -1 : 1);
             triggerNote(world, tilePos);
@@ -52,28 +52,28 @@ public class BlockLogicNote extends BlockLogic
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         changePitch(world, tilePos, 1);
         triggerNote(world, tilePos);
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
         if (!world.isClientSide) {
             triggerNote(world, tilePos);
         }
     }
 
-    public void changePitch(@NotNull World world, @NotNull TilePos tilePos, int delta) {
+    public void changePitch(@NotNull World world, @NotNull TilePosc tilePos, int delta) {
         int meta = world.getBlockData(tilePos);
         world.setBlockData(tilePos, setNote(meta, (getNote(meta) + (MAX_NOTE + 1) + delta) % (MAX_NOTE + 1)));
     }
 
-    public void triggerNote(@NotNull World world, @NotNull TilePos tilePos) {
-        if(world.isBlockOpaqueCube(tilePos.up())) {
+    public void triggerNote(@NotNull World world, @NotNull TilePosc tilePos) {
+        if (world.isBlockOpaqueCube(tilePos.up(new TilePos()))) {
             return;
         }
-        world.triggerEvent(tilePos, Instrument.getInstrumentFromBlock(world.getBlock(tilePos.down())).index, getNote(world.getBlockData(tilePos)));
+        world.triggerEvent(tilePos, Instrument.getInstrumentFromBlock(world.getBlock(tilePos.down(new TilePos()))).index, getNote(world.getBlockData(tilePos)));
     }
 
     public static int setNote(int data, int note) {
@@ -97,96 +97,96 @@ public class BlockLogicNote extends BlockLogic
     }
 
     @Override
-    public void triggerEvent(@NotNull World world, @NotNull TilePos tilePos, int index, int data) {
-        float f = (float)Math.pow(2D, (double)(data - 12) / 12D);
+    public void triggerEvent(@NotNull World world, @NotNull TilePosc tilePos, int index, int data) {
+        float f = (float) Math.pow(2D, (double) (data - 12) / 12D);
         String s = Instrument.getInstrumentFromIndex(index).soundKey;
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D, "note." + s, 3F, f);
-        world.spawnParticle("note", (double) tilePos.x + 0.5D, (double) tilePos.y + 1.2D, (double) tilePos.z + 0.5D, 0.0, 0.0D, 0.0D, data);
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "note." + s, 3F, f);
+        world.spawnParticle("note", (double) tilePos.x() + 0.5D, (double) tilePos.y() + 1.2D, (double) tilePos.z() + 0.5D, 0.0, 0.0D, 0.0D, data);
     }
 
     public record Instrument(int index, String soundKey) {
-            public static final Int2ObjectMap<Instrument> instrumentMap = new Int2ObjectArrayMap<>();
+        public static final Int2ObjectMap<Instrument> instrumentMap = new Int2ObjectArrayMap<>();
 
         public Instrument(int index, String soundKey) {
-                this.index = index;
-                this.soundKey = soundKey;
+            this.index = index;
+            this.soundKey = soundKey;
 
-                assert !instrumentMap.containsKey(index) : "Only 1 instrument can be assigned per index!";
-                instrumentMap.put(index, this);
-            }
+            assert !instrumentMap.containsKey(index) : "Only 1 instrument can be assigned per index!";
+            instrumentMap.put(index, this);
+        }
 
-            public static @NotNull Instrument getInstrumentFromIndex(int index) {
-                if (instrumentMap.containsKey(index)) return instrumentMap.get(index);
-                LOGGER.warn("No instrument assign to index '{}'!", index);
-                return instrumentMap.getOrDefault(index, DEFAULT);
-            }
+        public static @NotNull Instrument getInstrumentFromIndex(int index) {
+            if (instrumentMap.containsKey(index)) return instrumentMap.get(index);
+            LOGGER.warn("No instrument assign to index '{}'!", index);
+            return instrumentMap.getOrDefault(index, DEFAULT);
+        }
+
+        public static @NotNull Instrument getInstrumentFromBlock(@Nullable Block<?> block) {
+            if (block == null) return DEFAULT;
 
-            public static @NotNull Instrument getInstrumentFromBlock(@Nullable Block<?> block) {
-                if (block == null) return DEFAULT;
-
-                if (block == Blocks.BLOCK_OLIVINE) {
-                    return CHIP_TRIANGLE;
-                }
-                if (block == Blocks.BLOCK_REDSTONE || block == Blocks.PUMPKIN_REDSTONE || block.getLogic() instanceof BlockLogicOreRedstone) { // Should be any block thats basically just redstone
-                    return GUITAR_ELECTRIC;
-                }
-                if (block == Blocks.CHEST_PLANKS_OAK || block == Blocks.CHEST_PLANKS_OAK_PAINTED) {
-                    return WOOD_BLOCK;
-                }
-
-                Material material = block.getMaterial();
-                if (material == Material.permafrost || material == Material.ice) {
-                    return CELESTA;
-                }
-                if (material.isStone()) {
-                    return BD;
-                }
-                if (material == Material.sand) {
-                    return SNARE;
-                }
-                if (material == Material.glass) {
-                    return HAT;
-                }
-                if (material == Material.wood) {
-                    return BASS_ATTACK;
-                }
-                if (material == Material.soulsand) {
-                    return CHANT;
-                }
-                if (material == Material.steel) {
-                    return DRUM_STEEL;
-                }
-
-                return DEFAULT;
+            if (block == Blocks.BLOCK_OLIVINE) {
+                return CHIP_TRIANGLE;
+            }
+            if (block == Blocks.BLOCK_REDSTONE || block == Blocks.PUMPKIN_REDSTONE || block.getLogic() instanceof BlockLogicOreRedstone) { // Should be any block thats basically just redstone
+                return GUITAR_ELECTRIC;
+            }
+            if (block == Blocks.CHEST_PLANKS_OAK || block == Blocks.CHEST_PLANKS_OAK_PAINTED) {
+                return WOOD_BLOCK;
             }
 
-            public static Instrument DEFAULT;
-            public static final Instrument BD;
-            public static final Instrument SNARE;
-            public static final Instrument HAT;
-            public static final Instrument BASS_ATTACK;
-            public static final Instrument HARP;
-            public static final Instrument CHANT;
-            public static final Instrument DRUM_STEEL;
-            public static final Instrument CHIP_TRIANGLE;
-            public static final Instrument GUITAR_ELECTRIC;
-            public static final Instrument CELESTA;
-            public static final Instrument WOOD_BLOCK;
-
-            static {
-                HARP = new Instrument(0, "harp");
-                BD = new Instrument(1, "bd");
-                SNARE = new Instrument(2, "snare");
-                HAT = new Instrument(3, "hat");
-                BASS_ATTACK = new Instrument(4, "bassattack");
-                CHANT = new Instrument(5, "chant");
-                DRUM_STEEL = new Instrument(6, "drum_steel");
-                CHIP_TRIANGLE = new Instrument(7, "chip_triangle");
-                GUITAR_ELECTRIC = new Instrument(8, "guitar_electric");
-                CELESTA = new Instrument(9, "celesta");
-                WOOD_BLOCK = new Instrument(10, "wood_block");
-
-                DEFAULT = HARP;
+            Material material = block.getMaterial();
+            if (material == Materials.PERMAFROST || material == Materials.ICE) {
+                return CELESTA;
+            }
+            if (material.isStone()) {
+                return BD;
+            }
+            if (material == Materials.SAND) {
+                return SNARE;
             }
+            if (material == Materials.GLASS) {
+                return HAT;
+            }
+            if (material == Materials.WOOD) {
+                return BASS_ATTACK;
+            }
+            if (material == Materials.SOUL_SAND) {
+                return CHANT;
+            }
+            if (material == Materials.STEEL) {
+                return DRUM_STEEL;
+            }
+
+            return DEFAULT;
+        }
+
+        public static Instrument DEFAULT;
+        public static final Instrument BD;
+        public static final Instrument SNARE;
+        public static final Instrument HAT;
+        public static final Instrument BASS_ATTACK;
+        public static final Instrument HARP;
+        public static final Instrument CHANT;
+        public static final Instrument DRUM_STEEL;
+        public static final Instrument CHIP_TRIANGLE;
+        public static final Instrument GUITAR_ELECTRIC;
+        public static final Instrument CELESTA;
+        public static final Instrument WOOD_BLOCK;
+
+        static {
+            HARP = new Instrument(0, "harp");
+            BD = new Instrument(1, "bd");
+            SNARE = new Instrument(2, "snare");
+            HAT = new Instrument(3, "hat");
+            BASS_ATTACK = new Instrument(4, "bassattack");
+            CHANT = new Instrument(5, "chant");
+            DRUM_STEEL = new Instrument(6, "drum_steel");
+            CHIP_TRIANGLE = new Instrument(7, "chip_triangle");
+            GUITAR_ELECTRIC = new Instrument(8, "guitar_electric");
+            CELESTA = new Instrument(9, "celesta");
+            WOOD_BLOCK = new Instrument(10, "wood_block");
+
+            DEFAULT = HARP;
         }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreNetherCoal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreNetherCoal.java
index 151771260..59693eb10 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreNetherCoal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreNetherCoal.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -14,7 +14,7 @@ public class BlockLogicOreNetherCoal extends BlockLogic
 
     public BlockLogicOreNetherCoal(@NotNull Block<?> block)
     {
-        super(block, Material.netherrack);
+        super(block, Materials.NETHERRACK);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index 946ec7253..606dda590 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -14,57 +14,55 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockLogicOreRedstone extends BlockLogic
-{
+public class BlockLogicOreRedstone extends BlockLogic {
     public static Int2IntArrayMap variantMap = new Int2IntArrayMap();
     private final boolean illuminated;
     private final @NotNull Block<?> normalBlock;
     private final @NotNull Block<?> illuminatedBlock;
-    public BlockLogicOreRedstone(@NotNull Block<?> block, @Nullable Block<?> parentBlock, @NotNull Material material, boolean illuminated, @NotNull Block<?> normalBlock, @NotNull Block<?> illuminatedBlock)
-    {
+
+    public BlockLogicOreRedstone(@NotNull Block<?> block, @Nullable Block<?> parentBlock, @NotNull Material material, boolean illuminated, @NotNull Block<?> normalBlock, @NotNull Block<?> illuminatedBlock) {
         super(block, material);
         this.illuminated = illuminated;
         this.normalBlock = normalBlock;
         this.illuminatedBlock = illuminatedBlock;
-        if (parentBlock != null){
+        if (parentBlock != null) {
             variantMap.put(parentBlock.id(), block.id());
         }
     }
 
     @Override
-    public int tickDelay()
-    {
+    public int tickDelay() {
         return 30;
     }
 
     @Override
-    public void onAttacked(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
+    public void onAttacked(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @NotNull Side side, double xHit, double yHit) {
         lightRedstone(world, tilePos);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         lightRedstone(world, tilePos);
         return false;
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         lightRedstone(world, tilePos);
     }
 
     @Override
-    public void onEntityWalkedOn(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity walker) {
+    public void onEntityWalkedOn(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity walker) {
         lightRedstone(world, tilePos);
     }
 
-    private void lightRedstone(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    private void lightRedstone(@NotNull World world, @NotNull TilePosc tilePos) {
         spawnParticles(world, tilePos);
         if (!this.illuminated) {
             world.scheduleBlockUpdate(tilePos, this.illuminatedBlock.id(), 20 + world.rand.nextInt(9 * 20));
@@ -73,14 +71,14 @@ public class BlockLogicOreRedstone extends BlockLogic
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
-        if(this.illuminated) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (this.illuminated) {
             world.setBlockIdNotify(tilePos, this.normalBlock.id());
         }
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         return this.illuminated;
     }
 
@@ -100,38 +98,39 @@ public class BlockLogicOreRedstone extends BlockLogic
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
-        if(this.illuminated) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (this.illuminated) {
             spawnParticles(world, tilePos);
         }
     }
 
-    private void spawnParticles(@NotNull World world, @NotNull TilePos tilePos) {
-		Random random = world.rand;
+    private void spawnParticles(@NotNull World world, @NotNull TilePosc tilePos) {
+        Random random = world.rand;
 
         final int brightness = 10;
-		
-		double d = 0.0625;
-		for (int i = 0; i < Direction.directions.length; i++) {
+
+        final double d = 0.0625;
+        TilePos queryPos = new TilePos();
+        for (int i = 0; i < Direction.directions.length; i++) {
             Direction dir = Direction.directions[i];
-			double px = (double) tilePos.x + random.nextFloat();
-			double py = (double) tilePos.y + random.nextFloat();
-			double pz = (double) tilePos.z + random.nextFloat();
+            double px = (double) tilePos.x() + random.nextFloat();
+            double py = (double) tilePos.y() + random.nextFloat();
+            double pz = (double) tilePos.z() + random.nextFloat();
 
-            if (!world.isBlockOpaqueCube(tilePos.add(dir))) {
+            if (!world.isBlockOpaqueCube(tilePos.add(dir, queryPos))) {
                 switch (dir) {
-                    case UP -> py = (tilePos.y + 1) + d;
-                    case DOWN -> py = (tilePos.y) - d;
-                    case SOUTH -> pz = (tilePos.z + 1) + d;
-                    case NORTH -> pz = (tilePos.z) - d;
-                    case EAST -> px = (tilePos.x + 1) + d;
-                    case WEST -> px = (tilePos.x) - d;
+                    case UP -> py = (tilePos.y() + 1) + d;
+                    case DOWN -> py = (tilePos.y()) - d;
+                    case SOUTH -> pz = (tilePos.z() + 1) + d;
+                    case NORTH -> pz = (tilePos.z()) - d;
+                    case EAST -> px = (tilePos.x() + 1) + d;
+                    case WEST -> px = (tilePos.x()) - d;
                 }
             }
 
-			if (px < tilePos.x || px > (tilePos.x + 1) || py < 0.0D || py > (tilePos.y + 1) || pz < tilePos.z || pz > (tilePos.z + 1)) {
-				world.spawnParticle("reddust", px, py, pz, 0, 0, 0, brightness);
-			}
-		}
+            if (px < tilePos.x() || px > (tilePos.x() + 1) || py < 0.0D || py > (tilePos.y() + 1) || pz < tilePos.z() || pz > (tilePos.z() + 1)) {
+                world.spawnParticle("reddust", px, py, pz, 0, 0, 0, brightness);
+            }
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
index fe3b3bb40..64a0ff38c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
@@ -8,17 +8,16 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicOverlayPebbles extends BlockLogic
-{
-    public BlockLogicOverlayPebbles(@NotNull Block<?> block, @NotNull Material material)
-    {
+public class BlockLogicOverlayPebbles extends BlockLogic {
+    public BlockLogicOverlayPebbles(@NotNull Block<?> block, @NotNull Material material) {
         super(block, material);
         setBlockBounds(0, 0, 0, 1, 0.0625F, 1);
     }
@@ -35,57 +34,49 @@ public class BlockLogicOverlayPebbles extends BlockLogic
     }
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        Block<?> block = world.getBlock(tilePos.down());
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        Block<?> block = world.getBlock(tilePos.down(new TilePos()));
         return block != null && block.getMaterial().isSolid();
     }
 
     @Override
-    public boolean canStay(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
         return canPlaceAt(world, tilePos);
     }
 
     @Override
-    public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id)
-    {
-        if (!canStay(world, tilePos))
-        {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
     }
 
     @Override
-    public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
-    {
-        if (dropCause == EnumDropCause.PICK_BLOCK)
-        {
-            return new ItemStack[] { new ItemStack(Items.AMMO_PEBBLE, 1) };
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        if (dropCause == EnumDropCause.PICK_BLOCK) {
+            return new ItemStack[]{new ItemStack(Items.AMMO_PEBBLE, 1)};
         }
-        return new ItemStack[] { new ItemStack(Items.AMMO_PEBBLE, data + 1) };
+        return new ItemStack[]{new ItemStack(Items.AMMO_PEBBLE, data + 1)};
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
index ade499de8..3077d4b15 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
@@ -1,56 +1,55 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
-public class BlockLogicPathDirt extends BlockLogic
-{
-	public BlockLogicPathDirt(@NotNull Block<?> block) {
-        super(block, Material.dirt);
+public class BlockLogicPathDirt extends BlockLogic {
+    public BlockLogicPathDirt(@NotNull Block<?> block) {
+        super(block, Materials.DIRT);
         block.setTicking(true);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
         block.withLightBlock(255);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
-        return AABB.fromPool(tilePos.x, tilePos.y, tilePos.z, tilePos.x + 1, tilePos.y + 1, tilePos.z + 1);
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        return new AABBd(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x() + 1, tilePos.y() + 1, tilePos.z() + 1);
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         super.onNeighborChanged(world, tilePos, id);
-        TilePos up = tilePos.up();
+        TilePos up = tilePos.up(new TilePos());
         Material material = world.getBlockMaterial(up);
         Block<?> b = world.getBlock(up);
-        if(material.isSolid() && b != Blocks.FENCE_GATE_PLANKS_OAK && b != Blocks.FENCE_GATE_PLANKS_OAK_PAINTED && b != Blocks.SIGN_WALL_PLANKS_OAK) {
+        if (material.isSolid() && b != Blocks.FENCE_GATE_PLANKS_OAK && b != Blocks.FENCE_GATE_PLANKS_OAK_PAINTED && b != Blocks.SIGN_WALL_PLANKS_OAK) {
             world.setBlockIdNotify(tilePos, Blocks.DIRT.id());
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity)
-    {
+    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
             case SILK_TOUCH, PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
             default -> new ItemStack[]{new ItemStack(Blocks.DIRT)};
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
index c2440798c..28b237c3c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPiePumpkin.java
@@ -1,11 +1,12 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.item.Items;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicPiePumpkin extends BlockLogicEdible
 {
@@ -16,17 +17,17 @@ public class BlockLogicPiePumpkin extends BlockLogicEdible
     }
 
     @Override
-    public int getHealAmount(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getHealAmount(@NotNull World world, @NotNull TilePosc tilePos) {
         return 5;
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int data = source.getBlockData(tilePos);
         float f = 0.0625F;
         float xMin = data >= 2 ? 0.5f : f;
         float zMin = data >= 3 ? 0.5f : f;
         float f2 = 0.375F;
-        return AABB.fromPool(xMin, 0.0F, zMin, 1.0F - f, f2, 1.0F - f);
+        return new AABBd(xMin, 0.0F, zMin, 1.0F - f, f2, 1.0F - f);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
index 1b91ab39f..51223d2ea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
@@ -1,18 +1,18 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicPlanks extends BlockLogic implements IPaintable {
     public BlockLogicPlanks(@NotNull Block<?> block) {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         world.setBlockId(tilePos, Blocks.PLANKS_OAK_PAINTED.id());
         Blocks.PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
     }
